import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import React, { Component } from 'react';
import { findDOMNode } from 'react-dom';
import TagInput from 'recruit-tag-input';
import DropList from './dropList';
import CommonMount from '@beisen-cmps/common-mount';
import './index.css';

var _default =
/*#__PURE__*/
function (_Component) {
  _inherits(_default, _Component);

  function _default(props) {
    var _this;

    _classCallCheck(this, _default);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(_default).call(this, props));
    _this.state = {
      children: props.children && props.children.length > 0 ? props.children : [],
      defaultItems: props.defaultItems && props.defaultItems.length > 0 ? props.defaultItems : []
    };
    _this.CommonMount = new CommonMount({
      containerId: 'DropdownList_ul',
      // 容器ID
      follow: true,
      // 是否滚动跟随，默认true
      fixed: true // 定位：fixed，false时为absolute

    });
    _this.onClose = _this.onClose.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.handleClick = _this.handleClick.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    return _this;
  }

  _createClass(_default, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.children !== this.props.children) {
        this.setState({
          children: nextProps.children
        });
      }
    }
  }, {
    key: "addItems",
    value: function addItems(event, val) {
      var single = this.props.single;
      var item = {
        text: val.text[0],
        value: val.value
      };

      if (single || single == undefined) {
        this.state.defaultItems = [item];
      } else {
        var defaultItems = _toConsumableArray(this.state.defaultItems);

        defaultItems.push(item);
        this.state.defaultItems = defaultItems;
      }

      this.setState(this.state);
      this.props.onSureClick && this.props.onSureClick(event, this.state.defaultItems);
    }
  }, {
    key: "renderDom",
    value: function renderDom() {
      var self = this;
      var dropdownDate = {
        limitCount: 10,
        multiple: true,
        children: this.state.children,
        dropdownWidth: this.tar.offsetWidth,
        hasSearch: false,
        itemClick: function itemClick(event, val) {
          self.CommonMount.unmountBox();
          self.addItems(event, val);
        }
      };
      var showAutoUl = React.createElement(DropList, dropdownDate);
      this.CommonMount.renderDom('mount-box-dropdownlist', // wrap's classname & id
      showAutoUl, // content dom
      this.tar, // 跟随目标
      [this.tar, //挂载目标节点
      {
        // 挂载元素宽高 {width: '', height: ''}
        width: this.tar.clientWidth,
        // 挂载宽度
        height: 260
      }], true, //labeL和input框是否为竖向结构，会留出对应的label空间
      0, //水平向左偏移量，为负数则向右
      false, //弹层靠左靠右模式，默认为false 靠左模式
      100, //window.onresize执行时间，默认100ms
      false, //输入框高度
      false //自定义zindex
      );
    }
  }, {
    key: "onClose",
    value: function onClose(event) {
      try {
        findDOMNode(this);
      } catch (e) {
        this.CommonMount.unmountBox();
        document.removeEventListener('mousedown', this.onClose);
        this.props.onClose && this.props.onClose("close");
        return;
      }

      var area = document.getElementById("DropdownList_ul");

      if (area && !area.contains(event.target)) {
        // if (event.target.className.indexOf('sys-icon-close')>-1|| event.target.className.indexOf('u-icon')>-1 || event.target.tagName === 'BODY') return;
        this.CommonMount.unmountBox();
        document.removeEventListener('mousedown', this.onClose);
        this.props.onClose && this.props.onClose("close");
      }
    }
  }, {
    key: "handleClick",
    value: function handleClick(event, value) {
      this.tar = event.target.parentNode;
      this.renderDom();
      document.removeEventListener('mousedown', this.onClose);
      document.addEventListener('mousedown', this.onClose);
    }
  }, {
    key: "render",
    value: function render() {
      var self = this;
      var _this$props = this.props,
          maxCount = _this$props.maxCount,
          onSearch = _this$props.onSearch,
          title = _this$props.title,
          isRequired = _this$props.isRequired,
          lablePos = _this$props.lablePos,
          lableTxt = _this$props.lableTxt,
          errorStatus = _this$props.errorStatus,
          errorMessage = _this$props.errorMessage;
      var option = {
        maxCount: 5,
        defaultItems: this.state.defaultItems,
        title: title //label文本
        ,
        isRequired: isRequired,
        lablePos: lablePos //label位置，true时在左边，false在上边
        ,
        lableTxt: lableTxt //label中文字对齐方式，true左对齐，false右对齐 
        ,
        errorStatus: errorStatus,
        errorMessage: errorMessage,
        onClick: function onClick(event, status, value) {
          self.handleClick(event, value);
        },
        onFocus: function onFocus(event, status, value) {},
        onChange: function onChange(event, status, value) {
          onSearch(event, value);
        },
        onBlur: function onBlur(event, status, value) {},
        addItemCallBack: function addItemCallBack(event, status, value) {},
        deleteItemCallBack: function deleteItemCallBack(event, status, value) {}
      };
      return React.createElement("div", null, React.createElement(TagInput, option));
    }
  }]);

  return _default;
}(Component);

export { _default as default };